VERSION 5.00
Object = "{B92DC4FA-1274-439E-844A-AD77E176C306}#1.0#0"; "roc8.ocx"
Begin VB.Form main 
   Appearance      =   0  'Flat
   Caption         =   "Demo - ReportEase Plus"
   ClientHeight    =   8220
   ClientLeft      =   1500
   ClientTop       =   3720
   ClientWidth     =   12780
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   8220
   ScaleWidth      =   12780
   Begin ROCLib.Roc Rep1 
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   855
      _Version        =   65536
      _ExtentX        =   1508
      _ExtentY        =   873
      _StockProps     =   160
      Standalone      =   -1  'True
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   120
      ScaleHeight     =   345
      ScaleWidth      =   465
      TabIndex        =   0
      Top             =   7800
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.Menu edit 
      Caption         =   "&Edit"
   End
   Begin VB.Menu Run 
      Caption         =   "&Run"
   End
   Begin VB.Menu RunDirect 
      Caption         =   "Run&Direct"
   End
   Begin VB.Menu View 
      Caption         =   "&View"
   End
   Begin VB.Menu Exit 
      Caption         =   "&Exit"
   End
End
Attribute VB_Name = "main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private Sub edit_Click()
   Dim temp As Integer
   Dim FileName As String
   Dim EditingForm As Integer

   ' check if ReportEase already active, one session per control allowed
   If FormParm.open Then
      MsgBox "A Form Editor Window Already Open!"
      Exit Sub
   End If


   EditingForm = True
   Call GetFormSelection(FileName, EditingForm) 'select a report template to edit

   If DlgResult >= 0 Then ' A form selected
      FormParm.file = FileName + Chr(0)  ' specify the file name

      temp = RvbForm(Rep1.pCtl, FormParm)
      If temp <> 0 Then MsgBox "Error calling the Form Editor!"
   End If

End Sub

Private Sub Exit_Click()
   Unload main
End Sub

Private Sub Form_Load()
    Dim temp As Integer
    Dim i As Integer

    ' Initialize the form editor input structure
    
    FormParm.open = False ' form editor not yet open
    FormParm.x = 0    ' x position in pixel units
    FormParm.y = 0    ' y position in pixel units

    ' width and height in pixel units
    FormParm.width = Screen.width / Screen.TwipsPerPixelX
    FormParm.height = Screen.height / Screen.TwipsPerPixelY
    FormParm.height = (FormParm.height * 9) / 10

    FormParm.file = Chr(0)              ' no file name yet
    FormParm.DataSetName = "CUSTOMER" + Chr(0) ' data set name

    FormParm.ShowMenu = True            ' show menu bar
    FormParm.ShowHorBar = True          ' show horizontal scroll bar
    FormParm.ShowVerBar = True          ' show vertical scroll bar
    FormParm.ShowToolbar = True         ' show the built-in toolbar

    FormParm.hInst = 0
    FormParm.hPrevInst = 0

    FormParm.hFrWnd = 0                 ' RvbForm function fills in the editor window handle
    FormParm.hParentWnd = hWnd          ' Handle of the for which contains the roc control

    FormParm.style = WS_OVERLAPPEDWINDOW ' editor window style

    FormParm.FontTypeFace = Chr(0)      ' use default type face
    
    ' Initialize the report input parameter structure
    RepParm.hInst = 0
    RepParm.hPrevInst = 0
    RepParm.hParentWnd = hWnd           ' window handle for the form which contains the roc control
    RepParm.style = WS_OVERLAPPEDWINDOW ' window style
    RepParm.SwapDir = Chr(0)            ' default swap directory
    RepParm.SuppressPrintMessages = False ' show print messages
    RepParm.UseCurrentPrinter = False ' use the printer specified in the form
    RepParm.OutFile = Chr(0)          ' use default
    
    ' Initialize the report viewer parameter structure
    ViewParm.file = Chr(0)              ' let the API do the file selection
    ViewParm.device = "A"
    ViewParm.x = FormParm.x            ' output window location
    ViewParm.y = FormParm.y
    ViewParm.width = FormParm.width    ' output window width
    ViewParm.height = FormParm.height  ' output window height
    ViewParm.hInst = 0
    ViewParm.hPrevInst = 0
    ViewParm.hParentWnd = hWnd         ' window handle for the form which contains the roc control
    ViewParm.style = WS_OVERLAPPEDWINDOW ' window style
    ViewParm.SwapDir = Chr(0)            ' default swap directory
    ViewParm.SuppressPrintMessages = False ' show print messages

    ' set the demo data file names and read the field names
    DataFile(0).name = "CUSTOMER"
    DataFile(1).name = "SALES"

    For i = 0 To MAX_FILES - 1
      ReadFields (i)
    Next i

    ' load the customer logo bitmap
    Picture1.Picture = LoadPicture("LOGO.BMP")

End Sub



'  This function returns the form files found in the
'  current directory.  It also reads each file to get
'  the report description from the file
'
Private Sub GetFormFiles(wildcard As String)
    Dim FileName As String
    Dim iFile As Integer
    Dim FormHdr As TypeFormHdr

    FileName = Dir(wildcard, 0)
    iFile = 1                ' file number

    Do While FileName <> ""
    
       ' oprn and read the file header
       Open FileName For Binary Access Read As #iFile

       ErrorCode = 0
       On Error GoTo ErrorGetFormFiles
       Get #iFile, 1, FormHdr
       On Error GoTo 0
       
       If ErrorCode = 0 And TotalForms < MAX_FORMS Then   ' add to the list
          If FormHdr.FormSign = FORM_SIGN Then
            FormName(TotalForms) = FormHdr.name
            FormFile(TotalForms) = FileName
            TotalForms = TotalForms + 1
          End If
       End If
    
       Close iFile

       ' get the next file
       FileName = Dir        ' get the next file

    Loop

    Exit Sub

ErrorGetFormFiles:
    ErrorCode = Err
    Resume Next

End Sub

'  This routine displays the report template available in
'  the current directory and lets use select a file to
'  edit.
'
Private Sub GetFormSelection(FileName As String, FormEdit As Integer)

    FileName = ""        ' initialize the file name
    TotalForms = 0       ' total form files

    Call GetFormFiles("*.FPC") ' accumulate the files with the .FPC extension

    ' add new report option to form selection
    If FormEdit Then
       NewReport = TotalForms ' index of the new report option
       TotalForms = TotalForms + 1
       FormName(NewReport) = "New Report Form"
       FormFile(NewReport) = ""
    End If

    FrmEdit.Show 1

    If DlgResult >= 0 Then FileName = FormFile(DlgResult)

End Sub

' This routine sorts the CUSTOMER file.  It also creates
' a combined by joining the sorted CUSTOMER file and the
' SALES file
'
Private Sub PrepareFile(RepParm As TypeRep)
   Dim i As Integer
   Static KeyFieldNo(10)  As Long
   Dim temp As Integer
   Dim field As TypeField
   Dim OutName As String
   
   ' prepare the sorted file name
   OutName = "temp" + Str(RepParm.ReportId) + ".srt"

   ' sort the customer file
   For i = 0 To RepParm.TotalSortFields - 1   ' Get the sort fields
      temp = RvbGetSortField(Rep1.pCtl, i, field) 'get the sort field name
      KeyFieldNo(i) = field.FieldId + 1
   Next i
   temp = FileSort(DataFile(0).name + ".DB", OutName, RepParm.TotalSortFields, KeyFieldNo(0))
   
   ' The sorted records are stored in the TEMPnnn.SRT file
   '    Where nnn is the report id

   ' Check if the SALES file is used for this report
   SalesFileUsed = False
   For i = 0 To RepParm.TotalFields
      temp = RvbGetDataField(Rep1.pCtl, i, field) ' get the field information
      If field.FileId = 1 Then
         SalesFileUsed = True
         Exit For
      End If
   Next i

   If Not SalesFileUsed Then Exit Sub  ' do not need to join the sales file

   ' Join the SALES.DB file to the CUSTOMER.SRT file
   ' These two files have the first common field (customer id)
   temp = FileJoin(OutName, 1, DataFile(1).name + ".DB", 1, OutName)
   
   ' The output records are stored in the CUSTOMER.SRT file

End Sub

Private Sub PrepareFileDirect(RepParm As TypeRep)
   Dim i As Integer
   Static KeyFieldNo(10)  As Long
   Dim temp As Integer
   Dim field As TypeField
   Dim OutName As String
   
   ' prepare the sorted file name
   OutName = "temp" + Str(RepParm.ReportId) + ".srt"

   ' sort the customer file
   For i = 0 To RepParm.TotalSortFields - 1   ' Get the sort fields
      temp = RvdGetSortField(RepParm.ReportId, i, field) 'get the sort field name
      KeyFieldNo(i) = field.FieldId + 1
   Next i
   temp = FileSort(DataFile(0).name + ".DB", OutName, RepParm.TotalSortFields, KeyFieldNo(0))
   
   ' The sorted records are stored in the TEMPnnn.SRT file
   '    Where nnn is the report id

   ' Check if the SALES file is used for this report
   SalesFileUsed = False
   For i = 0 To RepParm.TotalFields
      temp = RvdGetDataField(RepParm.ReportId, i, field) ' get the field information
      If field.FileId = 1 Then
         SalesFileUsed = True
         Exit For
      End If
   Next i

   If Not SalesFileUsed Then Exit Sub  ' do not need to join the sales file

   ' Join the SALES.DB file to the CUSTOMER.SRT file
   ' These two files have the first common field (customer id)
   temp = FileJoin(OutName, 1, DataFile(1).name + ".DB", 1, OutName)
   
   ' The output records are stored in the CUSTOMER.SRT file

End Sub

'  This routine reads each record from the sorted data file
'  (CUSTOMER.SRT) and fills the values for the report fields
'  and calls the RvbRec function pass the data to the
'  report executor.
'
Private Sub PrintRecords(RepParm As TypeRep)
   Dim i As Integer
   Dim CurLen As Integer
   Dim iFile As Integer
   Dim FileNo As Integer
   Dim FieldNo As Integer
   Dim RecoNo  As Integer
   Dim DataSetName As String
   Dim DataValue As Variant
   Dim FileName As String
   Dim temp As Integer
   Dim field As TypeField
   Dim MaxFiles As Integer
   Dim FieldSource As Long
   Dim FieldType As Long
   Dim FileId As Long
   Dim FieldId As Long

   ' open the sorted data file
   FileName = "temp" + Str(RepParm.ReportId) + ".SRT"

   iFile = 1
   Open FileName For Input Access Read As #iFile

   ' Check if SALES data file is used
   If SalesFileUsed Then MaxFiles = MAX_FILES Else MaxFiles = 1

   ' Retrieve the information about the fields used in this report
   For i = 0 To RepParm.TotalFields - 1
      temp = RvbGetDataField(Rep1.pCtl, i, field)
      RepFieldSource(i) = field.source
      RepFieldType(i) = field.type
      RepFieldId(i) = field.FieldId
      RepFileId(i) = field.FileId
   Next i


READ_RECORD:
   ' Initialize the field structure
   For i = 0 To RepParm.TotalFields - 1
      If RepFieldSource(i) = SRC_APPL Then
        If RepFieldType(i) = TYPE_TEXT Then temp = RvbSetTextField(Rep1.pCtl, i, "", 0)
        If RepFieldType(i) = TYPE_NUM Then temp = RvbSetNumField(Rep1.pCtl, i, (0))
        If RepFieldType(i) = TYPE_DBL Then temp = RvbSetNumField(Rep1.pCtl, i, (0))
      End If
   Next i

   ' read fields values for the next record
   For FileNo = 0 To MaxFiles - 1
     For FieldNo = 0 To DataFile(FileNo).TotalFields - 1
       ErrorCode = 0
       On Error GoTo PrintRecordsHandler
       Input #iFile, DataValue
       On Error GoTo 0
       If ErrorCode Then
          Close iFile
          Exit Sub
       End If

       ' Pass this data field to the VBX
       For i = 0 To RepParm.TotalFields - 1
          If RepFieldSource(i) = SRC_APPL And RepFileId(i) = FileNo And RepFieldId(i) = FieldNo Then
             If RepFieldType(i) = TYPE_TEXT Then temp = RvbSetTextField(Rep1.pCtl, i, DataValue, Len(DataValue))
             If RepFieldType(i) = TYPE_NUM Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_DBL Then temp = RvbSetDoubleField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_DATE Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_PICT Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)  ' pass picture id
             If RepFieldType(i) = TYPE_LOGICAL Then
                If DataValue = "Y" Or DataValue = "y" Then DataValue = 1 Else DataValue = 0
                temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             End If
          End If
       Next i
     Next FieldNo
   Next FileNo

   ' Print the record
   temp = RvbRec(Rep1.pCtl)
   If temp <> 0 Then     ' user aborted the report
     Close iFile
     Exit Sub
   End If

   GoTo READ_RECORD

PrintRecordsHandler:
   ErrorCode = Err
   Resume Next

End Sub

Private Sub PrintRecordsDirect(RepParm As TypeRep)
   Dim i As Integer
   Dim CurLen As Integer
   Dim iFile As Integer
   Dim FileNo As Integer
   Dim FieldNo As Integer
   Dim RecoNo  As Integer
   Dim DataSetName As String
   Dim DataValue As Variant
   Dim FileName As String
   Dim temp As Integer
   Dim field As TypeField
   Dim MaxFiles As Integer
   Dim FieldSource As Long
   Dim FieldType As Long
   Dim FileId As Long
   Dim FieldId As Long

   ' open the sorted data file
   FileName = "temp" + Str(RepParm.ReportId) + ".SRT"

   iFile = 1
   Open FileName For Input Access Read As #iFile

   ' Check if SALES data file is used
   If SalesFileUsed Then MaxFiles = MAX_FILES Else MaxFiles = 1

   ' Retrieve the information about the fields used in this report
   For i = 0 To RepParm.TotalFields - 1
      temp = RvdGetDataField(RepParm.ReportId, i, field)
      RepFieldSource(i) = field.source
      RepFieldType(i) = field.type
      RepFieldId(i) = field.FieldId
      RepFileId(i) = field.FileId
   Next i


READ_RECORD:
   ' Initialize the field structure
   For i = 0 To RepParm.TotalFields - 1
      If RepFieldSource(i) = SRC_APPL Then
        If RepFieldType(i) = TYPE_TEXT Then temp = RvdSetTextField(RepParm.ReportId, i, "", 0)
        If RepFieldType(i) = TYPE_NUM Then temp = RvdSetNumField(RepParm.ReportId, i, (0))
        If RepFieldType(i) = TYPE_DBL Then temp = RvdSetNumField(RepParm.ReportId, i, (0))
      End If
   Next i

   ' read fields values for the next record
   For FileNo = 0 To MaxFiles - 1
     For FieldNo = 0 To DataFile(FileNo).TotalFields - 1
       ErrorCode = 0
       On Error GoTo PrintRecordsHandler
       Input #iFile, DataValue
       On Error GoTo 0
       If ErrorCode Then
          Close iFile
          Exit Sub
       End If

       ' Pass this data field to the VBX
       For i = 0 To RepParm.TotalFields - 1
          If RepFieldSource(i) = SRC_APPL And RepFileId(i) = FileNo And RepFieldId(i) = FieldNo Then
             If RepFieldType(i) = TYPE_TEXT Then temp = RvdSetTextField(RepParm.ReportId, i, DataValue, Len(DataValue))
             If RepFieldType(i) = TYPE_NUM Then temp = RvdSetNumField(RepParm.ReportId, i, DataValue)
             If RepFieldType(i) = TYPE_DBL Then temp = RvdSetDoubleField(RepParm.ReportId, i, DataValue)
             If RepFieldType(i) = TYPE_DATE Then temp = RvdSetNumField(RepParm.ReportId, i, DataValue)
             If RepFieldType(i) = TYPE_PICT Then temp = RvdSetNumField(RepParm.ReportId, i, DataValue)  ' pass picture id
             If RepFieldType(i) = TYPE_LOGICAL Then
                If DataValue = "Y" Or DataValue = "y" Then DataValue = 1 Else DataValue = 0
                temp = RvdSetNumField(RepParm.ReportId, i, DataValue)
             End If
          End If
       Next i
     Next FieldNo
   Next FileNo

   ' Print the record
   temp = RvdRec(RepParm.ReportId)
   If temp <> 0 Then     ' user aborted the report
     Close iFile
     Exit Sub
   End If

   GoTo READ_RECORD

PrintRecordsHandler:
   ErrorCode = Err
   Resume Next

End Sub

'  This routine reads the field definition file for the
'  specified file and extracts the individual field names
'  and field properties.
'
Private Sub ReadFields(FileNo As Integer)
   Dim FileName As String
   Dim TextLine As String
   Dim CharReturn As String
   Dim CurLen As Integer
   Dim FieldNo As Integer
   Dim LineIdx As Integer
   Dim FieldType As String
   Dim iFile As Integer
   

   FieldNo = 0
   DataFile(FileNo).TotalFields = 0

   ' open the field definition file
   FileName = DataFile(FileNo).name + ".DF" 'field definition file
   iFile = 1
   Open FileName For Input Access Read As #iFile

READ_LINE:

    ErrorCode = 0
    On Error GoTo ErrorHandler
    Input #iFile, DataField(FileNo, FieldNo).ShortName, DataField(FileNo, FieldNo).width, FieldType, DataField(FileNo, FieldNo).DecPlaces
    On Error GoTo 0
    If ErrorCode Then
       Close iFile
       Exit Sub
    End If

    ' construct other fields
    DataField(FileNo, FieldNo).FullName = DataFile(FileNo).name + "->" + DataField(FileNo, FieldNo).ShortName

    If FieldType = "T" Then DataField(FileNo, FieldNo).type = TYPE_TEXT
    If FieldType = "N" Then DataField(FileNo, FieldNo).type = TYPE_NUM
    If FieldType = "F" Then DataField(FileNo, FieldNo).type = TYPE_DBL
    If FieldType = "D" Then DataField(FileNo, FieldNo).type = TYPE_DATE
    If FieldType = "L" Then DataField(FileNo, FieldNo).type = TYPE_LOGICAL
    If FieldType = "P" Then DataField(FileNo, FieldNo).type = TYPE_PICT

    ' increment the field no
    FieldNo = FieldNo + 1
    DataFile(FileNo).TotalFields = FieldNo

    GoTo READ_LINE

ErrorHandler:
    ErrorCode = Err
    Resume Next

End Sub

' This event is fired by the ReportExecutor when it needs
' your application to draw a picture.  This routine calls
' the RvbGetPictureInfo function to get the report device
' context, picture id, and rectangle locaton and size where
' the picture is to be drawn. This function also returns
' the file and field id for the picture field (this demo
' program does not use these two fields).
'
' This demo program draw different part of the same bitmap
' for different picture id.
'
Private Sub Rep1_DrawPicture(ByVal ReportId As Long)
   Dim PictInfo As TypePict
   Dim temp As Integer
   Dim PictWidth As Integer
   Dim PictX As Integer
   Dim PictY As Integer
   Dim PictHeight As Integer
   Dim PictFile As String
   
   ' get the report device context and picture rectangle
   temp = RvbGetPictureInfo(Rep1.pCtl, PictInfo)
    
   If PictInfo.FieldId = 11 Then ' draw a bitmap
     ' specify part of the bitmap to print as a percentage of the width and height
     If PictInfo.PictId < 1 Then PictInfo.PictId = 1
     If PictInfo.PictId > 10 Then PictInfo.PictId = 10
   
     PictX = (PictInfo.PictId - 1) * 10  'starting X location
     PictWidth = 10               'always print only 10 percent of the bitmap
     PictY = 0
     PictHeight = 100             ' print the entire height

     ' The following statment uses the RvbDrawBitmap function
     ' to draw a part of the logo.bmp file.  The logo.bmp
     ' bitmap file is loaded into the 'Picture1' control.
     ' The 'AutoSize' property of the picture control MUST
     ' be TRUE so that the control does not clip the
     ' bitmap.

     temp = RvbDrawBitmap(Rep1.pCtl, Picture1.hWnd, Picture1.Image, PictX, PictY, PictWidth, PictHeight)
     
   ElseIf PictInfo.FieldId = 12 Then ' Draw an RTF memo field
      
     If PictInfo.PictId = 1 Then PictFile = "letter1.rtf" Else PictFile = "letter2.rtf"
     temp = RepDrawTerText(ReportId, PictFile + Chr(0), 0, 0, ByVal 0&, ByVal 0&)
   End If

End Sub


'  This function responds to the field selection event.
'  This routine can be programmed by your application in
'  any way as long as it returns the data about the selected
'  field using the RvbGetFormField/RvbSetFormField functions.
'
'  In this routine we will allow the user to first select a file and then
'  select a field from the chosen file.  The required data about the selected
'  field is filled into the 'field' structure variable and passed over to
'  ReportEase using the RvbSetFormField function.
'
'  The 'SortLevel' parameter of the RvbGetFormField funtion
'  specified the sort level if this field will be used for
'  a section break.  If your application will not sort on all
'  fields, you can restrict the fields that can be selected by the user.
'  For a non-sort field, this parameter is set to 0.  In this
'  demo program, we will allow only the fields from the primary
'  file (CUSTOMER) to be used as sort fields.
'
'
Private Sub Rep1_SelectField()
    Dim field As TypeField
    Dim SortLevel As Long
    Dim temp As Long
    Dim CurField As Integer
    
    ' get the input field structure
    temp = RvbGetFormField(Rep1.pCtl, field, SortLevel)
    
    If SortLevel = 0 Then   ' select regular data field
        FrmFile.Show 1      ' select a data file
        'GetField           ' alternate method to get file/field
    Else                    ' select sort field
        CurFile = 0         ' sort field from the CUSTOMER file only
        FrmField.Show 1    ' select a data field
    End If

    ' return the result
    CurField = DlgResult
    If CurField >= 0 Then
      ' pass the basic field information
      field.name = DataField(CurFile, CurField).FullName + Chr(0) ' NULL terminate a string
      field.type = DataField(CurFile, CurField).type
      field.width = DataField(CurFile, CurField).width
      field.DecPlaces = DataField(CurFile, CurField).DecPlaces

      ' specify new paragraph indicator field.  Use only
      ' for a word-wrapped text type fields
      field.ParaChar = "|"

      ' Fill up these OPTIONAL fields also.  This information
      ' will be used by our report generator demo program
      ' to identify the fields quickly.

      field.FileId = CurFile
      field.FieldId = CurField

      temp = RvbSetFormField(Rep1.pCtl, field, True)
    End If
End Sub

Private Sub Rep1_Unload()
   FormParm.open = False ' indicate the ReportEase as closed
End Sub

' This event is fired by the VBX to validate a field. The
' field data should be retrieved by using the
' RvbGetFormField function call. The field name in the
' 'field' structure contains the file prefix (if your
' application allows it).  The field name is always in
' the upper case.  This routine should fill the required
' data about the field.  Your program may also fill the
' remaining 'field' structure variables.
'
' The RvbGetFormField function also returns the sort level
' for the field, if the field is being used for sort break.
' The value of 1 indicates the first sort field, 2 the second, ...
' The 0 value for SortLevel indicates that the field is
' not used for sort break.
'
' In this demo program, we will allow only the fields from
' the primary file (CUSTOMER) to be used as sort fields.
'
' This routine returns a True value using the RvbSetFormField
' if the field is valid.  Otherwise it returns a FALSE value.
'
'
Private Sub Rep1_VerifyField()
   Dim i As Integer
   Dim j As Integer
   Dim MaxFiles As Integer
   Dim field As TypeField
   Dim SortLevel As Long
   Dim temp As Integer
   Dim FieldName As String

   temp = RvbGetFormField(Rep1.pCtl, field, SortLevel)

   ' discard the NULL character from the field name
   FieldName = DiscardNull(field.name)
   
   MaxFiles = MAX_FILES
   If SortLevel > 0 Then MaxFiles = 1
   
   ' test every file
   For i = 0 To MaxFiles - 1
     ' test every field for a file
     For j = 0 To DataFile(i).TotalFields - 1
        If DataField(i, j).FullName = FieldName Then
           ' note that 'name' in the 'field' structure is
           ' terminated by a NULL character
           field.type = DataField(i, j).type
           field.width = DataField(i, j).width
           field.DecPlaces = DataField(i, j).DecPlaces

           ' specify new paragraph indicator field.  Use only
           ' for a word-wrapped text type fields
           field.ParaChar = "|"

           ' Fill up these OPTIONAL fields also.  This information
           ' will be used by our report generator demo program
           ' to identify the fields quickly.

           field.FileId = i
           field.FieldId = j

           temp = RvbSetFormField(Rep1.pCtl, field, True)
           
           Exit Sub

        End If

     Next j
   Next i


End Sub


' run the report using the direct dll calls
Private Sub RunDirect_Click()
   Dim temp As Integer
   Dim FileName As String
   Dim EditingForm As Integer
   Dim tag As String
   
   ' check if ReportEase already active, only one session per control allowed
   If FormParm.open Then
      MsgBox "A Form Editor Window Already Open!"
      Exit Sub
   End If
   FormParm.open = True

   EditingForm = False
   Call GetFormSelection(FileName, EditingForm) 'select a report template to edit

   If DlgResult < 0 Then Exit Sub     ' a form not selected
   
   ' fill the report parameter structure
   RepParm.file = FileName + Chr(0)  ' specify the file name
   RepParm.device = "D"              ' output device, D = pdf; A = Ask User
   RepParm.OutFile = "test.pdf" + Chr(0)  ' write the pdf to the test.pdf file
   RepParm.x = FormParm.x            ' output window location
   RepParm.y = FormParm.y
   RepParm.width = FormParm.width    ' output window width
   RepParm.height = FormParm.height  ' output window height
   RepParm.hParentWnd = hWnd         ' parent window handle

   
   ' Initialize the report executor for standalone execution
   temp = RvdInit(RepParm, AddressOf DrawPictureDirect)          ' initialize the report
   If temp <> 0 Then Exit Sub
   
   Call RvdSetProgressCallback(RepParm.ReportId, AddressOf PrintProgress)
   
   'test of RvdPict functions
   'Call RvdPictureListAdd(RepParm.ReportId, "key1", "tag1", LoadPicture("test1.bmp").Handle) ' works with or without .Handle
   'Call RvdPictureListAdd(RepParm.ReportId, "key2", "tag2", LoadPicture("test2.bmp").Handle)
   'Call RvdPictureListAdd(RepParm.ReportId, "key3", "tag3", LoadPicture("test3.bmp").Handle)
   
   Call RvdPictureListAddFromFile(RepParm.ReportId, "key1", "tag1", "test1.bmp") ' works with or without .Handle
   Call RvdPictureListAddFromFile(RepParm.ReportId, "key2", "tag2", "test2.bmp")
   Call RvdPictureListAddFromFile(RepParm.ReportId, "key3", "tag3", "test3.bmp")
   
   Debug.Print "exists key1: ", RvdPictureListExists(RepParm.ReportId, "key1"), RvdPictureListGet(RepParm.ReportId, "key1")
   Debug.Print "exists key2: ", RvdPictureListExists(RepParm.ReportId, "key2"), RvdPictureListGet(RepParm.ReportId, "key2")
   Debug.Print "exists key3: ", RvdPictureListExists(RepParm.ReportId, "key3"), RvdPictureListGet(RepParm.ReportId, "key3")
   
   Call RvdPictureListRemove(RepParm.ReportId, "key2")
   'Call RvdPictureListReplace(RepParm.ReportId, "key1", "tag4", LoadPicture("test4.bmp").Handle)
   Call RvdPictureListReplaceFromFile(RepParm.ReportId, "key1", "tag4", "test.png")
   
   Debug.Print "exists key1: ", RvdPictureListExists(RepParm.ReportId, "key1"), RvdPictureListGet(RepParm.ReportId, "key1")
   Debug.Print "exists key2: ", RvdPictureListExists(RepParm.ReportId, "key2"), RvdPictureListGet(RepParm.ReportId, "key2")
   Debug.Print "exists key3: ", RvdPictureListExists(RepParm.ReportId, "key3"), RvdPictureListGet(RepParm.ReportId, "key3")
   
   tag = Space$(20)
   temp = RvdPictureListGetTag(RepParm.ReportId, "key1", tag)
   If (temp <> 0) Then Debug.Print "tag for key1: ", tag
   
   tag = Space$(20)
   temp = RvdPictureListGetTag(RepParm.ReportId, "key2", tag)
   If (temp <> 0) Then Debug.Print "tag for key2: ", tag
   
   tag = Space$(20)
   temp = RvdPictureListGetTag(RepParm.ReportId, "key3", tag)
   If (temp <> 0) Then Debug.Print "tag for key3: ", tag
   
   
   ' prepare the datafile for output
   Call PrepareFileDirect(RepParm)

   ' Do a preprocess pass if requested by the report executor
   If (RepParm.DoPreprocessPass) Then
      temp = RepBeginPreprocessPass(RepParm.ReportId)
      Call PrintRecords(RepParm)
      temp = RepEndPreprocessPass(RepParm.ReportId)
   End If
   
   ' Feed the records to the report executor
   Call PrintRecordsDirect(RepParm)

   ' Close the report executor
   temp = RvdExit(RepParm.ReportId)

End Sub
  
Private Sub Run_Click()
   Dim temp As Integer
   Dim FileName As String
   Dim EditingForm As Integer

   ' check if ReportEase already active, only one session per control allowed
   If FormParm.open Then
      MsgBox "A Form Editor Window Already Open!"
      Exit Sub
   End If
   FormParm.open = True

   EditingForm = False
   Call GetFormSelection(FileName, EditingForm) 'select a report template to edit

   If DlgResult < 0 Then Exit Sub     ' a form not selected
   
   ' fill the report parameter structure
   RepParm.file = FileName + Chr(0)  ' specify the file name
   RepParm.device = "A"              ' output device, A = Ask User
   RepParm.x = FormParm.x            ' output window location
   RepParm.y = FormParm.y
   RepParm.width = FormParm.width    ' output window width
   RepParm.height = FormParm.height  ' output window height
   RepParm.hParentWnd = hWnd         ' parent window handle

   
   ' Initialize the report executor
   temp = RvbInit(Rep1.pCtl, RepParm)          ' initialize the report
   If temp <> 0 Then Exit Sub
   
   ' prepare the datafile for output
   Call PrepareFile(RepParm)

   ' Do a preprocess pass if requested by the report executor
   If (RepParm.DoPreprocessPass) Then
      temp = RepBeginPreprocessPass(RepParm.ReportId)
      Call PrintRecords(RepParm)
      temp = RepEndPreprocessPass(RepParm.ReportId)
   End If
   
   ' Feed the records to the report executor
   Call PrintRecords(RepParm)

   ' Close the report executor
   temp = RvbExit(Rep1.pCtl)

End Sub

Private Sub View_Click()
   Dim temp As Integer
   
   ' check if ReportEase already active, one session per control allowed
   If FormParm.open Then
      MsgBox "A Form Editor Window Already Open!"
      Exit Sub
   End If
   FormParm.open = True

   ' invoke the report viewer
   ViewParm.file = Chr(0)              ' let the API do the file selection
   ViewParm.device = "A"
   temp = RvbView(Rep1.pCtl, ViewParm)
End Sub

' The GetField function presents an alternate method of letting user select
' file/field.  This method uses the Report list box functions to display
' a list box for file/field section.  This method may be useful in an
' environment which does not allow for modal dialog boxes.
Sub GetField()
   Dim i As Integer
   Dim temp As Integer

   temp = RepListInit(Rep1.hFrWnd, "Select a Data File", -1, -1)
   For i = 0 To MAX_FILES - 1
     temp = RepListAppend(Rep1.hFrWnd, DataFile(i).name)
   Next
   
   DlgResult = RepListShow(Rep1.hFrWnd) ' select a data file

   If (DlgResult >= 0) Then
      CurFile = DlgResult
      temp = RepListInit(Rep1.hFrWnd, "Select a Data Field", -1, -1)

      For i = 0 To DataFile(CurFile).TotalFields
        temp = RepListAppend(Rep1.hFrWnd, DataField(CurFile, i).ShortName)
      Next
      DlgResult = RepListShow(Rep1.hFrWnd) ' select a data field
   End If

End Sub
