VERSION 5.00
Object = "{B92DC4FA-1274-439E-844A-AD77E176C306}#1.0#0"; "roc8.ocx"
Begin VB.Form FrmReportViewer 
   Caption         =   "Report Viewer"
   ClientHeight    =   10755
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   12840
   LinkTopic       =   "Form1"
   ScaleHeight     =   10755
   ScaleWidth      =   12840
   StartUpPosition =   3  'Windows Default
   Begin ROCLib.Roc Rep1 
      Height          =   10455
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   12615
      _Version        =   65536
      _ExtentX        =   22251
      _ExtentY        =   18441
      _StockProps     =   160
      DesignMode      =   0   'False
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open..."
      End
      Begin VB.Menu mnuSave 
         Caption         =   "Save..."
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuJump 
         Caption         =   "Goto Page..."
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPrint 
         Caption         =   "&Print"
      End
      Begin VB.Menu mnuPrintPreview 
         Caption         =   "Print Pre&view"
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "FrmReportViewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Dim CloseWin As Long
  CloseWin = RepQueryExit(Rep1.hFrWnd)
  If CloseWin Then Cancel = 0 Else Cancel = 1
End Sub

Private Sub mnuOpen_Click()
   Dim temp As Integer

   ' invoke the report viewer
   ViewParm.file = Chr(0)          ' let the API do the file selection
   ViewParm.device = "S"           ' in Non-standalone mode, viewer output always goes to screen
   temp = RvbView(Rep1.pCtl, ViewParm)

End Sub

Private Sub mnuSave_Click()
  Rep1.Command = ID_SAVE
End Sub

Private Sub mnuExit_Click()
  Unload Me
End Sub

Private Sub mnuFile_Click()
   mnuSave.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_SAVE)
   mnuSave.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_SAVE)
   mnuJump.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_JUMP)
   mnuJump.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_JUMP)
   mnuPrint.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_PRINT)
   mnuPrint.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_PRINT)
   mnuPrintPreview.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_PREVIEW)
   mnuPrintPreview.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_PREVIEW)
   mnuExit.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_EXIT)
   mnuExit.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_EXIT)

End Sub

Private Sub mnuJump_Click()
  Rep1.Command = ID_JUMP
End Sub
Private Sub mnuPrint_Click()
  Rep1.Command = ID_PRINT
End Sub

Private Sub mnuPrintPreview_Click()
  Rep1.Command = ID_PREVIEW
End Sub

