VERSION 5.00
Object = "{B92DC4FA-1274-439E-844A-AD77E176C306}#1.0#0"; "roc8.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   9405
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   11790
   LinkTopic       =   "Form1"
   ScaleHeight     =   9405
   ScaleWidth      =   11790
   StartUpPosition =   3  'Windows Default
   Begin ROCLib.Roc Roc1 
      Height          =   9015
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   11535
      _Version        =   65536
      _ExtentX        =   20346
      _ExtentY        =   15901
      _StockProps     =   160
      DesignMode      =   0   'False
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "Run New.."
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save..."
      End
      Begin VB.Menu mnuFileSepBar1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "Print..."
      End
      Begin VB.Menu mnuFilePrintPreview 
         Caption         =   "Print Preview..."
      End
      Begin VB.Menu mnuFileSepBar2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileClose 
         Caption         =   "Close"
      End
   End
   Begin VB.Menu mnuOther 
      Caption         =   "&Other"
      Begin VB.Menu mnuOtherCopy 
         Caption         =   "Copy"
      End
      Begin VB.Menu mnuOtherSepBar1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOtherJump 
         Caption         =   "Jump..."
      End
      Begin VB.Menu mnuOtherSepBar2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOtherTestCode 
         Caption         =   "Other"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
   Call RepPrintFromPreview(Roc1.hFrWnd, vbNull, "", "", 0, 0)
End Sub

Private Sub Form_Load()
  ' set data definition files
  Roc1.MasterDefFile = "customer.df"
  Roc1.DetailDefFile = "sales.df"
  Roc1.OtherDefFiles = "states.df"

  ' set data files
  Roc1.MasterDataFile = "customer.db"
  Roc1.DetailDataFile = "sales.db"
  Roc1.OtherDataFiles = "states.db"
  
  ' set the file name which contains picture ids and picture names to be used to print
  Roc1.PictureNameFile = "PictNames.txt"
  
  ' Now run an initial report (optional)
  ' Note:  TemplateFile property should be set after assigning the data and
  '        definition file.  The assignment of the TemplateFile property
  '        triggers the report execution.
  
   'Roc1.TemplateFile = "saledate.fpc"      ' set the initial report file

End Sub

Private Sub Form_Resize()
 Roc1.Left = 0   ' size the form designer to form
 Roc1.Top = 0
 Roc1.width = Me.ScaleWidth
 Roc1.height = Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Dim CloseWin As Long
  CloseWin = Roc1.RepQueryExit()
  If CloseWin Then Cancel = 0 Else Cancel = 1

End Sub

Private Sub mnuFile_Click()
   
   mnuFileNew.Enabled = Roc1.RepMenuEnable(ID_OPEN)
   mnuFileNew.Checked = Roc1.RepMenuSelect(ID_OPEN)
  
   mnuFileSave.Enabled = Roc1.RepMenuEnable(ID_SAVE)
   mnuFileSave.Checked = Roc1.RepMenuSelect(ID_SAVE)

   mnuFilePrint.Enabled = Roc1.RepMenuEnable(ID_PRINT)
   mnuFilePrint.Checked = Roc1.RepMenuSelect(ID_PRINT)

   mnuFilePrintPreview.Enabled = Roc1.RepMenuEnable(ID_PRINT_PREVIEW)
   mnuFilePrintPreview.Checked = Roc1.RepMenuSelect(ID_PRINT_PREVIEW)

   mnuFileClose.Enabled = Roc1.RepMenuEnable(ID_QUIT)
   mnuFileClose.Checked = Roc1.RepMenuSelect(ID_QUIT)

End Sub

Private Sub mnuOther_Click()
   
   mnuOtherCopy.Enabled = Roc1.RepMenuEnable(ID_COPY)
   mnuOtherCopy.Checked = Roc1.RepMenuSelect(ID_COPY)
  
   mnuOtherJump.Enabled = Roc1.RepMenuEnable(ID_JUMP)
   mnuOtherJump.Checked = Roc1.RepMenuSelect(ID_JUMP)

End Sub

Private Sub mnuFileNew_Click()
   Roc1.Command = ID_OPEN
End Sub

Private Sub mnuFileSave_Click()
   Roc1.Command = ID_SAVE
End Sub

Private Sub mnuFilePrint_Click()
   Roc1.Command = ID_PRINT
End Sub

Private Sub mnuFilePrintPreview_Click()
   Roc1.Command = ID_PREVIEW
End Sub

Private Sub mnuFileClose_Click()

'Just unload the form. There is code in the form_query unload that closes ReportEase.
Unload Me

End Sub

Private Sub mnuOtherCopy_Click()
   Roc1.Command = ID_COPY
End Sub

Private Sub mnuOtherJump_Click()
   Roc1.Command = ID_JUMP
End Sub


Private Sub mnuOtherTestCode_Click()
  Dim PrtName As String
  
  PrtName = Space$(1000) ' allocate space for the printer name
  Call RepGetCurPrinter(PrtName)
  Call RepPrintFromPreview(Roc1.hFrWnd, PrtName, "", "", 1, 1)
End Sub

Private Sub Roc1_Progress(ByVal PagesPrinted As Long, Cancel As Long)
  debug "page printed: ",PagesPrinted
End Sub

Private Sub Roc1_SelectField()

End Sub
